---
title: CanvasRenderingContext2D.fillRect()
slug: Web/API/CanvasRenderingContext2D/fillRect
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p><span class="seoSummary">The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.fillRect()</code></strong> method of the Canvas 2D API draws a rectangle that is filled according to the current {{domxref("CanvasRenderingContext2D.fillStyle", "fillStyle")}}.</span></p>

<p>This method draws directly to the canvas without modifying the current path, so any subsequent {{domxref("CanvasRenderingContext2D.fill()", "fill()")}} or {{domxref("CanvasRenderingContext2D.stroke()", "stroke()")}} calls will have no effect on it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.fillRect(<em>x</em>, <em>y</em>, <em>width</em>, <em>height</em>);
</pre>

<p>The <code>fillRect()</code> method draws a filled rectangle whose starting point is at <code>(x, y)</code> and whose size is specified by <code>width</code> and <code>height</code>. The fill style is determined by the current <code>fillStyle</code> attribute.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>The x-axis coordinate of the rectangle's starting point.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis coordinate of the rectangle's starting point.</dd>
 <dt><code>width</code></dt>
 <dd>The rectangle's width. Positive values are to the right, and negative to the left.</dd>
 <dt><code>height</code></dt>
 <dd>The rectangle's height. Positive values are down, and negative are up.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_filled_rectangle">A simple filled rectangle</h3>

<p>This example draws a filled green rectangle using the <code>fillRect()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The rectangle's top-left corner is at (20, 10). It has a width of 150 and a height of 100.</p>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
ctx.fillStyle = 'green';
ctx.fillRect(20, 10, 150, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('A_simple_filled_rectangle', 700, 180) }}</p>

<h3 id="Filling_the_whole_canvas">Filling the whole canvas</h3>

<p>This code snippet fills the entire canvas with a rectangle. This is often useful for creating a background, on top of which other things may then be drawn. To achieve this, the dimensions of the rectangle are set to equal the {{HtmlElement("canvas")}} element's <code>width</code> and <code>height</code> attributes.</p>

<pre class="brush: js; highlight:[3]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
ctx.fillRect(0, 0, canvas.width, canvas.height);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-fillrect", "CanvasRenderingContext2D.fillRect")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.fillRect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.fillStyle")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.clearRect()")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.strokeRect()")}}</li>
</ul>
